from pathlib import Path
from typing import override

from jinja2 import Template
from maestro import BaseArtefactModel, FileArtefactModel
from maestro.config import Config as MaestroConfig

with open(Path(__file__).parent.parent / "templates" / "steps_artefact.html") as f:
    TEMPLATE = Template(f.read())


class StepsBaseArtefact(BaseArtefactModel):
    """Base class for artefacts generated by steps."""

    @override
    @property
    def html(self) -> str:
        return TEMPLATE.render(obj=self)


class StepsBaseFileArtefact(FileArtefactModel):
    """Base class for file artefacts generated by steps."""

    instance_id: str = MaestroConfig.INSTANCE_ID

    @override
    @property
    def html(self) -> str:
        return TEMPLATE.render(obj=self)
